### R code from vignette source 'biGraph.Rnw'

###################################################
### code chunk number 1: reg
###################################################
library(biGraph)
data(g)
summary(g)


###################################################
### code chunk number 2: reg
###################################################
V(g)[type==TRUE]
V(g)[type==FALSE]


###################################################
### code chunk number 3: fig1_plot
###################################################
plot(g,layout=layout.fruchterman.reingold,vertex.label=gsub('_','\n',V(g)$dname),vertex.color=V(g)$col,vertex.label.color='black',vertex.label.dist=0.5,vertex.label.family='Helvetica',vertex.label.cex=0.6, edge.label.cex=0.6)


###################################################
### code chunk number 4: fig1_b
###################################################
plot(g,layout=layout.fruchterman.reingold,vertex.label=gsub('_','\n',V(g)$dname),vertex.color=V(g)$col,vertex.label.color='black',vertex.label.dist=0.5,vertex.label.family='Helvetica',vertex.label.cex=0.6, edge.label.cex=0.6)


###################################################
### code chunk number 5: fig2_plot
###################################################
proj <- bipartite.projection(g)
plot(proj[[2]],layout=layout.fruchterman.reingold,vertex.label=gsub('_','\n',V(g)[type==TRUE]$name),vertex.color=V(g)[type==TRUE]$col,vertex.label.color='black',vertex.label.dist=0.5,vertex.label.family='Helvetica',vertex.label.cex=0.6, edge.label.cex=0.6)


###################################################
### code chunk number 6: fig2_b
###################################################
proj <- bipartite.projection(g)
plot(proj[[2]],layout=layout.fruchterman.reingold,vertex.label=gsub('_','\n',V(g)[type==TRUE]$name),vertex.color=V(g)[type==TRUE]$col,vertex.label.color='black',vertex.label.dist=0.5,vertex.label.family='Helvetica',vertex.label.cex=0.6, edge.label.cex=0.6)


###################################################
### code chunk number 7: reg
###################################################
proj <- bipartite.projection.informationloss(g,vType=TRUE,measures='complete')
proj[[1]]$H.delta
summary(V(proj[[1]])$H.delta)
summary(E(proj[[1]])$H.delta)
summary(E(proj[[1]])$covLoss)
summary(V(proj[[1]])$avCovLoss)


###################################################
### code chunk number 8: fig9_plot
###################################################
plot(proj[[1]],layout=layout.fruchterman.reingold,vertex.label=gsub('_','\n',V(proj[[1]])$name),vertex.color=V(g)[type==TRUE]$col,vertex.label.color='black',vertex.label.dist=0.5,vertex.label.family='Helvetica',vertex.label.cex=0.6, edge.label.cex=0.6,vertex.size=(V(proj[[1]])$H.after*3)+2,edge.width=(E(proj[[1]])$covLoss*5)+1)


###################################################
### code chunk number 9: fig9_b
###################################################
plot(proj[[1]],layout=layout.fruchterman.reingold,vertex.label=gsub('_','\n',V(proj[[1]])$name),vertex.color=V(g)[type==TRUE]$col,vertex.label.color='black',vertex.label.dist=0.5,vertex.label.family='Helvetica',vertex.label.cex=0.6, edge.label.cex=0.6,vertex.size=(V(proj[[1]])$H.after*3)+2,edge.width=(E(proj[[1]])$covLoss*5)+1)


###################################################
### code chunk number 10: fig7_plot
###################################################
plot(V(proj[[1]])$H.before,V(proj[[1]])$H.after,xlab='Uncertainty before projection [nats]',ylab='Uncertainty after projection [nats]',pch=20,cex=1.5,xlim=c(0,4),ylim=c(0,4))


###################################################
### code chunk number 11: fig7_b
###################################################
plot(V(proj[[1]])$H.before,V(proj[[1]])$H.after,xlab='Uncertainty before projection [nats]',ylab='Uncertainty after projection [nats]',pch=20,cex=1.5,xlim=c(0,4),ylim=c(0,4))


###################################################
### code chunk number 12: fig3_plot
###################################################
proj_weighted <- get.weighted.projection(g,vType=TRUE,mode='shared-neighbours')
plot(proj_weighted,layout=layout.fruchterman.reingold,vertex.color=V(g)[type==TRUE]$col,vertex.label='',vertex.label.family='Helvetica',edge.label.family='Helvetica',edge.label=E(proj_weighted)$weight,vertex.label.cex=0.6, edge.label.cex=0.6,vertex.label.dist=0.5)


###################################################
### code chunk number 13: fig3_b
###################################################
proj_weighted <- get.weighted.projection(g,vType=TRUE,mode='shared-neighbours')
plot(proj_weighted,layout=layout.fruchterman.reingold,vertex.color=V(g)[type==TRUE]$col,vertex.label='',vertex.label.family='Helvetica',edge.label.family='Helvetica',edge.label=E(proj_weighted)$weight,vertex.label.cex=0.6, edge.label.cex=0.6,vertex.label.dist=0.5)


###################################################
### code chunk number 14: reg
###################################################
lpi(g,vType=FALSE)


###################################################
### code chunk number 15: fig4_plot
###################################################
write.lpi(lpi(g,vType=FALSE,mode='minimal'),'minimal.lpi')
lp <- read.lpi('minimal.lpi')
for (i in V(lp$graph)){c<-V(g)[which(V(g)$name==V(lp$graph)[i]$name)-1]$col; if(length(c)>0){V(lp$graph)[i]$col=c;V(lp$graph)[i]$size=10}else{V(lp$graph)[i]$col='white';V(lp$graph)[i]$size=5}}
plot(lp$graph,layout=layout.fruchterman.reingold,vertex.label=gsub('_','\n',V(lp$graph)$name),vertex.label.family='Helvetica',vertex.label.cex=0.6, edge.label.cex=0.6,vertex.label.color='black',vertex.label.dist=0.5,vertex.color=V(lp$graph)$col,vertex.size=V(lp$graph)$size)


###################################################
### code chunk number 16: fig4_b
###################################################
write.lpi(lpi(g,vType=FALSE,mode='minimal'),'minimal.lpi')
lp <- read.lpi('minimal.lpi')
for (i in V(lp$graph)){c<-V(g)[which(V(g)$name==V(lp$graph)[i]$name)-1]$col; if(length(c)>0){V(lp$graph)[i]$col=c;V(lp$graph)[i]$size=10}else{V(lp$graph)[i]$col='white';V(lp$graph)[i]$size=5}}
plot(lp$graph,layout=layout.fruchterman.reingold,vertex.label=gsub('_','\n',V(lp$graph)$name),vertex.label.family='Helvetica',vertex.label.cex=0.6, edge.label.cex=0.6,vertex.label.color='black',vertex.label.dist=0.5,vertex.color=V(lp$graph)$col,vertex.size=V(lp$graph)$size)


###################################################
### code chunk number 17: reg
###################################################
write.lpi(lpi(g,vType=FALSE,mode='basic'),'basic.lpi')
lp <- read.lpi('basic.lpi')
graph.isomorphic(g,lp$graph)


###################################################
### code chunk number 18: reg
###################################################
graph.density(g)


###################################################
### code chunk number 19: reg
###################################################
bipartite.graph.density(g)


###################################################
### code chunk number 20: reg
###################################################
degree.centrality(g)
bipartite.closeness.centrality(g)
bipartite.betweenness.centrality(g)


###################################################
### code chunk number 21: fig8_plot
###################################################
plot(g,layout=layout.fruchterman.reingold,vertex.label=gsub('_','\n',V(g)$dname),vertex.color=V(g)$col,vertex.label.color='black',vertex.label.dist=0.5,vertex.label.family='Helvetica',vertex.label.cex=0.6, edge.label.cex=0.6,vertex.size=((10*bipartite.betweenness.centrality(g)[[1]])+2)*1.5)


###################################################
### code chunk number 22: fig8_b
###################################################
plot(g,layout=layout.fruchterman.reingold,vertex.label=gsub('_','\n',V(g)$dname),vertex.color=V(g)$col,vertex.label.color='black',vertex.label.dist=0.5,vertex.label.family='Helvetica',vertex.label.cex=0.6, edge.label.cex=0.6,vertex.size=((10*bipartite.betweenness.centrality(g)[[1]])+2)*1.5)


###################################################
### code chunk number 23: reg
###################################################
single.mode.degree.centralization(g)
single.mode.closeness.centralization(g)
single.mode.betweenness.centralization(g)


